class Gui {

	static VerticalScrollBarWidth
	
	Window()
	{
		global XmlGroupBox
			, XmlFileEdit
			, XmlFileButton
			, XsltGroupBox
			, XsltListView
			, AddXsltButton
			, RemoveXsltButton
			, XsltUpButton
			, XsltDownButton
			, ParameterGroupBox
			, ParameterListView
			, AddParameterButton
			, EditParameterButton
			, RemoveParameterButton
			, TransformationButton
			, DialogHwnd := {}
		SysGet, VSBW, 2 ; SM_CXVSCROLL  VerticalScrollBarWidth
		this.VerticalScrollBarWidth := VSBW
		Gui, +Resize +MinSize
		Gui, Add, GroupBox, w470 h62 Section vXmlGroupBox, % Txt.Get("XmlGroupBox")
		Gui, Add, Edit, xs13 ys24 w413 h20 ReadOnly vXmlFileEdit
		Gui, Add, Button, xp416 yp-1 w30 h22 vXmlFileButton hwndOpenButton gEvent.XmlFileButton
		GuiButtonIcon(OpenButton, "resources\folder-open.ico")
		Gui, Add, GroupBox, xs0 w470 h152 Section vXsltGroupBox, % Txt.Get("XsltGroupBox")
		Gui, Add, ListView, xs13 ys24 w444 r5 -Hdr -E0x200 -Multi AltSubmit vXsltListView gXsltListViewEvent, XsltStylesheets
		GuiControlGet, ControlPos, Pos, XsltListView
		;MsgBox % "XsltListViewH: " ControlPosH
		Gui, Add, Button, % "yp" ControlPosH + 7 " xp-1 vAddXsltButton gEvent.AddXsltButton Disabled"
			, % " " Txt.Get("AddXsltButton") " "
		GuiControlGet, ControlPos, Pos, AddXsltButton
		Gui, Add, Button, % "xp" ControlPosW + 5 " yp0 vRemoveXsltButton gEvent.RemoveXsltButton Disabled"
			, % " " Txt.Get("RemoveXsltButton") " "
		GuiControlGet, ControlPos, Pos, RemoveXsltButton
		Gui, Add, Button, % "xp" ControlPosW + 5 " yp0 w30 vXsltUpButton hwndUpButton gEvent.XsltUpButton Disabled"
		GuiButtonIcon(UpButton, "resources\up.ico")
		Gui, Add, Button, xp35 yp0 w30 vXsltDownButton hwndDownButton gEvent.XsltDownButton Disabled
		GuiButtonIcon(DownButton, "resources\down.ico")
		Gui, Add, GroupBox, xs0 w470 h176 Section vParameterGroupBox, % Txt.Get("ParameterGroupBox")
		Gui, Add, ListView, xs13 ys24 w444 r5 -E0x200 -LV0x10 NoSortHdr -Multi AltSubmit vParameterListView gParameterListViewEvent
			, % Txt.Get("ParameterListViewNameCol") "|" Txt.Get("ParameterListViewValueCol")
		GuiControlGet, ControlPos, Pos, ParameterListView
		Gui, Add, Button, % "yp" ControlPosH + 7 " xp-1 vAddParameterButton gEvent.AddParameterButton Disabled"
			, % " " Txt.Get("AddParameterButton") " "
		GuiControlGet, ControlPos, Pos, AddParameterButton
		Gui, Add, Button, % "xp" ControlPosW + 5 " yp0 vEditParameterButton gEvent.EditParameterButton Disabled"
			, % " " Txt.Get("EditParameterButton") " "
		GuiControlGet, ControlPos, Pos, EditParameterButton
		Gui, Add, Button, % "xp" ControlPosW + 5 " yp0 vRemoveParameterButton gEvent.RemoveParameterButton Disabled"
			, % " " Txt.Get("RemoveParameterButton") " "
		Gui, Add, Button, xs0 ys191 h30 w470 vTransformationButton gEvent.TransformationButton Disabled
			, % Txt.Get("TransformationButton")
		Gui, Show,, % Txt.Get("WindowTitle")
	}
	
	XmlFileEdit[]
	{
		get {
			global XmlFileEdit
			GuiControlGet, EditText,, XmlFileEdit
			return EditText
		}
		set {
			global XmlFileEdit
			GuiControl,, XmlFileEdit, % value
		}
	}
	
	XsltListView[Mode := ""]
	{
		set {
			global XsltListView
			if (A_DefaultListView != "XsltListView") {
				Gui, ListView, XsltListView
			}
			if (Mode = "Select") {
				RowNumber := (value) ? value : LV_GetCount()
				LV_Modify(RowNumber, "Select")
				GuiControl, Focus, XsltListView
			} else {
				GuiControl, Focus, XsltListView
				LV_Delete()
				for index, href in value {
					LV_Add("",href)
				}
			}
		}
	}
	
	AddXsltButton[]
	{
		set {
			global AddXsltButton
			GuiControl, Enable%value%, AddXsltButton
		}
	}
	
	RemoveXsltButton[]
	{
		set {
			global RemoveXsltButton
			GuiControl, Enable%value%, RemoveXsltButton
		}
	}
	
	XsltUpButton[]
	{
		set {
			global XsltUpButton
			GuiControl, Enable%value%, XsltUpButton
		}
	}
	
	XsltDownButton[]
	{
		set {
			global XsltDownButton
			GuiControl, Enable%value%, XsltDownButton
		}
	}
	
	ParameterListView[]
	{
		set {
			global ParameterListView
			if (A_DefaultListView != "ParameterListView")	{
				Gui, ListView, ParameterListView
			}
			LV_Delete()
			for parameterName, parameterValue in value {
				LV_Add("", parameterName, parameterValue)
			}
		}
	}
	
	AddParameterButton[]
	{
		set {
			global AddParameterButton
			GuiControl, Enable%value%, AddParameterButton
		}
	}
	
	EditParameterButton[]
	{
		set {
			global EditParameterButton
			GuiControl, Enable%value%, EditParameterButton
		}
	}
	
	RemoveParameterButton[]
	{
		set {
			global RemoveParameterButton
			GuiControl, Enable%value%, RemoveParameterButton
		}
	}
	
	TransformationButton[]
	{
		set {
			global TransformationButton
			GuiControl, Enable%value%, TransformationButton
		}
	}
}

;* Function for Gui Resizing

GuiSize()
{
	global XmlGroupBox
		, XmlFileEdit
		, XmlFileButton
		, XsltGroupBox
		, XsltListView
		, AddXsltButton
		, RemoveXsltButton
		, XsltUpButton
		, XsltDownButton
		, ParameterGroupBox
		, ParameterListView
		, AddParameterButton
		, EditParameterButton
		, RemoveParameterButton
		, TransformationButton
	if ErrorLevel = 1  ; The window has been minimized.  No action needed.
		return
	NewWidth := A_GuiWidth - 20
	, NewXmlFileEditWidth := A_GuiWidth - 77
	, NewXmlFileButtonX := A_GuiWidth - 51
	, NewXsltHeight := (152 / 328) * (A_GuiHeight - 130)
	, NewParameterHeight := (176 / 328) * (A_GuiHeight - 130)
	, NewListViewWidth := A_GuiWidth - 46
	, NewParameterButtonY := A_GuiHeight - 83
	, NewButtonY := A_GuiHeight - 41
	, VerticalScrollBarWidth := Gui.VerticalScrollBarWidth
	NewXsltListViewColWidth := NewListViewWidth - VerticalScrollBarWidth
	, NewXsltListViewHeight := A_GuiHeight - NewParameterHeight - 193
	, NewXsltButtonY := A_GuiHeight - NewParameterHeight - 88
	, NewParameterY := 81 + NewXsltHeight
	, NewParameterListViewHeight := A_GuiHeight - NewXsltHeight - 193
	, NewParameterListViewY := 104 + NewXsltHeight
	, NewParameterListViewColWidth := (NewListViewWidth - VerticalScrollBarWidth) / 2
	
	GuiControl, MoveDraw, XmlGroupBox, % "w" NewWidth
	GuiControl, MoveDraw, XmlFileEdit, % "w" NewXmlFileEditWidth
	GuiControl, MoveDraw, XmlFileButton, % "x" NewXmlFileButtonX
	GuiControl, MoveDraw, XsltGroupBox, % "w" NewWidth " h" NewXsltHeight
	if (A_DefaultListView != "XsltListView") {
		Gui, ListView, XsltListView
	}
	LV_ModifyCol(1, NewXsltListViewColWidth)
	GuiControl, MoveDraw, XsltListView, % "w" NewListViewWidth " h" NewXsltListViewHeight
	GuiControl, MoveDraw, AddXsltButton, % "y" NewXsltButtonY
	GuiControl, MoveDraw, RemoveXsltButton, % "y" NewXsltButtonY
	GuiControl, MoveDraw, XsltUpButton, % "y" NewXsltButtonY
	GuiControl, MoveDraw, XsltDownButton, % "y" NewXsltButtonY
	GuiControl, MoveDraw, ParameterGroupBox, % "y" NewParameterY " w" NewWidth " h" NewParameterHeight
	Gui, ListView, ParameterListView
	LV_ModifyCol(1, NewParameterListViewColWidth)
	LV_ModifyCol(2, NewParameterListViewColWidth)
	GuiControl, MoveDraw, ParameterListView, % "y" NewParameterListViewY " w" NewListViewWidth " h" NewParameterListViewHeight
	GuiControl, MoveDraw, AddParameterButton, % "y" NewParameterButtonY
	GuiControl, MoveDraw, EditParameterButton, % "y" NewParameterButtonY
	GuiControl, MoveDraw, RemoveParameterButton, % "y" NewParameterButtonY
	GuiControl, MoveDraw, TransformationButton, % "y" NewButtonY " w" NewWidth
}

;* Function to add Icons to Buttons

GuiButtonIcon(Handle, File, Index := 1, Options := "")
{
	RegExMatch(Options, "i)w\K\d+", W), (W="") ? W := 16 :
	RegExMatch(Options, "i)h\K\d+", H), (H="") ? H := 16 :
	RegExMatch(Options, "i)s\K\d+", S), S ? W := H := S :
	RegExMatch(Options, "i)l\K\d+", L), (L="") ? L := 0 :
	RegExMatch(Options, "i)t\K\d+", T), (T="") ? T := 0 :
	RegExMatch(Options, "i)r\K\d+", R), (R="") ? R := 0 :
	RegExMatch(Options, "i)b\K\d+", B), (B="") ? B := 0 :
	RegExMatch(Options, "i)a\K\d+", A), (A="") ? A := 4 :
	Psz := A_PtrSize = "" ? 4 : A_PtrSize, DW := "UInt", Ptr := A_PtrSize = "" ? DW : "Ptr"
	VarSetCapacity( button_il, 20 + Psz, 0 )
	NumPut( normal_il := DllCall( "ImageList_Create", DW, W, DW, H, DW, 0x21, DW, 1, DW, 1 ), button_il, 0, Ptr )	; Width & Height
	NumPut( L, button_il, 0 + Psz, DW )		; Left Margin
	NumPut( T, button_il, 4 + Psz, DW )		; Top Margin
	NumPut( R, button_il, 8 + Psz, DW )		; Right Margin
	NumPut( B, button_il, 12 + Psz, DW )	; Bottom Margin	
	NumPut( A, button_il, 16 + Psz, DW )	; Alignment
	SendMessage, BCM_SETIMAGELIST := 5634, 0, &button_il,, AHK_ID %Handle%
	return IL_Add( normal_il, File, Index )
}